org.springframework.http.codec.protobuf

## Class ProtobufEncoder

- java.lang.Object
- - org.springframework.http.codec.protobuf.ProtobufCodecSupport
  - - org.springframework.http.codec.protobuf.ProtobufEncoder

- All Implemented Interfaces:
    Encoder<com.google.protobuf.Message>, HttpMessageEncoder<com.google.protobuf.Message>

      public class ProtobufEncoder
      extends ProtobufCodecSupport
      implements HttpMessageEncoder<com.google.protobuf.Message>

  An `Encoder` that writes `Message`s using Google Protocol Buffers.

  Flux are serialized using delimited Protobuf messages with the size of each message specified before the message itself. Single values are serialized using regular Protobuf message format (without the size prepended before the message).

  To generate `Message` Java classes, you need to install the `protoc` binary.

  This encoder requires Protobuf 3 or higher, and supports `"application/x-protobuf"` and `"application/octet-stream"` with the official `"com.google.protobuf:protobuf-java"` library.

  Since:
    5.1
  Author:
    Sebastien Deleuze
  See Also:
    `ProtobufDecoder`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ProtobufEncoder()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canEncode(ResolvableType elementType, MimeType mimeType)` Whether the encoder supports the given source element type and the MIME type for the output stream.
    `reactor.core.publisher.Flux<DataBuffer>` | `encode(Publisher<? extends com.google.protobuf.Message> inputStream, DataBufferFactory bufferFactory, ResolvableType elementType, MimeType mimeType, Map<String,Object> hints)` Encode a stream of Objects of type `T` into a `DataBuffer` output stream.
    `DataBuffer` | `encodeValue(com.google.protobuf.Message message, DataBufferFactory bufferFactory, ResolvableType valueType, MimeType mimeType, Map<String,Object> hints)` Encode an Object of type T to a data buffer.
    `List<MimeType>` | `getEncodableMimeTypes()` Return the list of MIME types supported by this Encoder.
    `List<MediaType>` | `getStreamingMediaTypes()` Return "streaming" media types for which flushing should be performed automatically vs at the end of the input stream.

    - ### Methods inherited from class org.springframework.http.codec.protobuf.ProtobufCodecSupport

      `getMimeTypes, supportsMimeType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.http.codec.HttpMessageEncoder

      `getEncodeHints`

    - ### Methods inherited from interface org.springframework.core.codec.Encoder

      `getEncodableMimeTypes`

- - ### Constructor Detail

    - #### ProtobufEncoder

          public ProtobufEncoder()

  - ### Method Detail

    - #### canEncode

          public boolean canEncode(ResolvableType elementType,
                                   @Nullable
                                   MimeType mimeType)

      Description copied from interface: `Encoder`
      Whether the encoder supports the given source element type and the MIME type for the output stream.
      Specified by:
        `canEncode` in interface `Encoder<com.google.protobuf.Message>`
      Parameters:
        `elementType` - the type of elements in the source stream
        `mimeType` - the MIME type for the output stream (can be `null` if not specified)
      Returns:
        `true` if supported, `false` otherwise

    - #### encode

          public reactor.core.publisher.Flux<DataBuffer> encode(Publisher<? extends com.google.protobuf.Message> inputStream,
                                                                DataBufferFactory bufferFactory,
                                                                ResolvableType elementType,
                                                                @Nullable
                                                                MimeType mimeType,
                                                                @Nullable
                                                                Map<String,Object> hints)

      Description copied from interface: `Encoder`
      Encode a stream of Objects of type `T` into a `DataBuffer` output stream.
      Specified by:
        `encode` in interface `Encoder<com.google.protobuf.Message>`
      Parameters:
        `inputStream` - the input stream of Objects to encode. If the input should be encoded as a single value rather than as a stream of elements, an instance of `Mono` should be used.
        `bufferFactory` - for creating output stream `DataBuffer`'s
        `elementType` - the expected type of elements in the input stream; this type must have been previously passed to the `Encoder.canEncode(org.springframework.core.ResolvableType, org.springframework.util.MimeType)` method and it must have returned `true`.
        `mimeType` - the MIME type for the output content (optional)
        `hints` - additional information about how to encode
      Returns:
        the output stream

    - #### encodeValue

          public DataBuffer encodeValue(com.google.protobuf.Message message,
                                        DataBufferFactory bufferFactory,
                                        ResolvableType valueType,
                                        @Nullable
                                        MimeType mimeType,
                                        @Nullable
                                        Map<String,Object> hints)

      Description copied from interface: `Encoder`
      Encode an Object of type T to a data buffer. This is useful for scenarios, that distinct messages (or events) are encoded and handled individually, in fully aggregated form.

      By default this method raises `UnsupportedOperationException` and it is expected that some encoders cannot produce a single buffer or cannot do so synchronously (e.g. encoding a `Resource`).

      Specified by:
        `encodeValue` in interface `Encoder<com.google.protobuf.Message>`
      Parameters:
        `message` - the value to be encoded
        `bufferFactory` - for creating the output `DataBuffer`
        `valueType` - the type for the value being encoded
        `mimeType` - the MIME type for the output content (optional)
        `hints` - additional information about how to encode
      Returns:
        the encoded content

    - #### getStreamingMediaTypes

          public List<MediaType> getStreamingMediaTypes()

      Description copied from interface: `HttpMessageEncoder`
      Return "streaming" media types for which flushing should be performed automatically vs at the end of the input stream.
      Specified by:
        `getStreamingMediaTypes` in interface `HttpMessageEncoder<com.google.protobuf.Message>`

    - #### getEncodableMimeTypes

          public List<MimeType> getEncodableMimeTypes()

      Description copied from interface: `Encoder`
      Return the list of MIME types supported by this Encoder. The list may not apply to every possible target element type and calls to this method should typically be guarded via `canEncode(elementType, null)`. The list may also exclude MIME types supported only for a specific element type. Alternatively, use `Encoder.getEncodableMimeTypes(ResolvableType)` for a more precise list.
      Specified by:
        `getEncodableMimeTypes` in interface `Encoder<com.google.protobuf.Message>`
      Returns:
        the list of supported MIME types